// Output generated from file: R:/testfrag/test.frag
// Created:   14 23:06:08 2016
// Output generated from file: D:/fractal/Fragmentarium/Fragmentarium-1.0.25-Qt_5_4_2-MinGW/Examples/Tim/test.frag
// Created: wo 14. sep 20:25:39 2016
#info Amazing Surface by Kali - Based on Tglad's Amazing Box
#define providesInit

#include "DE-Kn2cr11.frag"

#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#define USE_IQ_CLOUDS

#include "MathUtils.frag"


#define USE_INF_NORM
#group AmazingSurface


uniform int Iterations;  slider[0,17,300]
uniform int ColorIterations;  slider[0,3,300]
uniform float MinRad2;  slider[0.00001,0.25,2.0]
uniform float Scale;  slider[-3,1.5,3.0]
uniform int FoldType; slider[1,1,3]
uniform vec3 PreTranslation; slider[(-5,-5,-5),(0,0,0),(5,5,5)]
uniform vec2 FoldValues; slider[(0,0),(1,1),(5,5)]
uniform bool Julia; checkbox[false]
uniform vec3 JuliaValues; slider[(-5,-5,-5),(-1,-1,-1),(5,5,5)]
uniform vec3 RotVector; slider[(-1,-1,-1),(1,1,1),(1,1,1)]
uniform float RotAngle; slider[-180,0,180]

mat3 rot;

void init() {
    rot = rotationMatrix3(normalize(RotVector), RotAngle);
}

vec4 scale = vec4(Scale, Scale, Scale, abs(Scale))/MinRad2;
float absScalem1 = abs(1-Scale);
float AbsScaleRaisedTo1mIters = pow(abs(Scale), float(1-Iterations));

float DE(vec3 pos) {
   vec4 p = vec4(pos,1);
   vec3 c = Julia?JuliaValues:p.xyz;  
   for (int i=0; i<Iterations; i++) {
      if (FoldType==1) p.xy=abs(p.xy+FoldValues)-abs(p.xy-FoldValues)-p.xy;
      if (FoldType==2) p.xy=FoldValues-abs(abs(p.xy)-FoldValues);
      if (FoldType==3) p.xy=abs(p.xy+FoldValues);
      p.xyz+=PreTranslation;
      float r2 = dot(p.xyz, p.xyz);
      if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(p.xyz,r2)));
      p *= clamp(max(MinRad2/r2, MinRad2), 0, 1.0);  
      p = p*scale;
      p.xyz+=c;
      p.xyz*=rot;
   }
   return ((length(p.xyz) - absScalem1) / p.w - AbsScaleRaisedTo1mIters);
}









#preset Default
FOV = 0.208333
Eye = 7.82123,2.65363,-0.977654
Target = 5.23935,2.84995,4.31257
UpLock = false
FocalPlane = 2.89792
Aperture = 0
InFocusAWidth = 0.97354
DofCorrect = true
ApertureNbrSides = 5
ApertureRot = 186.707
ApStarShaped = false
Gamma = 1.4
ToneMapping = 5
Exposure = 1.5
Brightness = 1
Contrast = 1
Saturation = 1.17376
GaussianWeight = 0.798838
AntiAliasScale = 0.2
Bloom = true
BloomIntensity = 2
BloomPow = 2
BloomTaps = 30
BloomStrong = 1
Detail = -4.25089
RefineSteps = 7
FudgeFactor = 0.97303
MaxRaySteps = 857
MaxDistance = 20
Dither = 0.92105
NormalBackStep = 1.8333
DetailAO = -1.85717
coneApertureAO = 1
maxIterAO = 40
FudgeAO = 1
AO_ambient = 1
AO_camlight = 0
AO_pointlight = 0
AoCorrect = 0
Specular = 0.05882
SpecularExp = 5
CamLight = 0.756863,0.937255,0.937255,0
AmbiantLight = 0.913725,0.968627,1,1
Reflection = 0.207843,0.184314,0.2
ReflectionsNumber = 0
SpotGlow = true
SpotLight = 0.823529,1,1,3
LightPos = 7.9846,1.613,2.4732
LightSize = 0.19345
LightFallOff = 0.77222
LightGlowRad = 1.10155
LightGlowExp = 1.83545
HardShadow = 1
ShadowSoft = 1.519
ShadowBlur = 0
perf = false
SSS = false
sss1 = 0.1
sss2 = 0.5
BaseColor = 0.6,0.619608,0.65098
OrbitStrength = 0.1039
X = 0.788235,1,1,1
Y = 0.45098,0.364706,0.219608,1
Z = 0.827451,0.764706,0.772549,0.767
R = 0.87451,0.862745,0.486275,0.96078
BackgroundColor = 0.137255,0.337255,0.576471
GradientBackground = 2.2826
CycleColors = true
Cycles = 1.31523
EnableFloor = false
FloorNormal = 0,0,1
FloorHeight = 0.5053
FloorColor = 1,1,1
HF_Fallof = 0.0005
HF_Const = 0
HF_Intensity = 0
HF_Dir = 0.58648,-0.3011,-0.39662
HF_Offset = -10
HF_Color = 0.835294,0.956863,0.984314,0
HF_Scatter = 4.6239
HF_Anisotropy = 0,0,0
HF_FogIter = 5
HF_CastShadow = true
EnCloudsDir = false
Clouds_Dir = 0,0,1
CloudScale = 0.24602
CloudFlatness = 0.08167
CloudTops = -10
CloudBase = -10
CloudDensity = 0.13491
CloudRoughness = 1.56126
CloudContrast = 5.9297
CloudColor = 0.905882,0.886275,0.588235
CloudColor2 = 0.07,0.17,0.24
SunLightColor = 0.698039,0.203922,0.105882
Cloudvar1 = 0.99
Cloudvar2 = 1
CloudIter = 5
CloudBgMix = 1
Iterations = 46
ColorIterations = 20
MinRad2 = 0.964064
Scale = -1.28512
FoldType = 3
PreTranslation = -3.20476,-0.988,-1.3784
FoldValues = 3.60615,1.6459
Julia = true
JuliaValues = -0.907781,0.965418,-1.54899
RotVector = 0.400862,0.29454,0.54023
RotAngle = -25.7514
Up = 0.893056,0.126029,0.431177
#endpreset

